extends Path2D
export(PackedScene) var enemy_scene_1
export(PackedScene) var enemy_scene_2

onready var SpawnLocation = $AntifaSpawnLocation
onready var SpawnTimer = $SpawnTimer
onready var SpeedTimer = $SpeedTimer

func _ready():
	randomize()


func spawn_enemy():
	SpawnLocation.unit_offset = randf()
	var enemy_rotation = SpawnLocation.rotation + PI + rand_range(-PI/2, PI/2)
	var enemy_position = SpawnLocation.global_position
	var enemy_scene = enemy_scene_1 if randi() % 2 == 0 else enemy_scene_2
	
	var enemy = Utils.defer_instance_to_scene(enemy_scene, enemy_position)
	enemy.rotation = enemy_rotation
	var enemy_motion = Vector2.UP.rotated(enemy_rotation ).normalized()
	enemy.apply_central_impulse(enemy_motion * enemy.SPEED)


func _on_SpawnTimer_timeout():
	spawn_enemy()


func start_spawning():
	# print("Starting to spawn enemies")
	if SpawnTimer.is_stopped():
		SpawnTimer.start()
	if SpeedTimer.is_stopped():
		SpeedTimer.start()


func increase_speed(factor=0.9):
	assert(factor < 1)
	var wait_time = SpawnTimer.wait_time
	SpawnTimer.wait_time = clamp(wait_time * factor, 0.3, INF)
	# print("New Spawning Speed: %f" % SpawnTimer.wait_time)
	if SpeedTimer.is_stopped():
		SpeedTimer.start()
