extends "res://Enemy/BaseEnemy.gd"

const Boom = preload("res://Effects/PowerUps/Fuel.tscn")

var MAX_ARMOR
var is_flipped

onready var Sprite = $Sprite


func print_type():
	print("Type NPCShip")


func _ready():
#	ARMOR = 13
#	COLLISION_DAMAGE = 4
#	MAX_ARMOR = ARMOR
	is_flipped = bool(randi() % 2)
	Sprite.flip_h = is_flipped


func destroy():
	if randi() % 4 == 0:
		if not VoiceBox.is_playing():
			VoiceBox.insult_npcs()
	.destroy()


func apply_damage(_damage_points):
	.apply_damage(_damage_points)
	if Stats.health > 0:
		var damage_percentage = 1 - (float(Stats.health) / Stats.MAX_HEALTH)
		Sprite.frame = clamp( round(Sprite.hframes * damage_percentage), 0, Sprite.hframes-1 )
		if Sprite.frame == 1:
			create_hit_effect(Vector2(-8, -8 if is_flipped else 8))
		elif Sprite.frame == 4:
			create_hit_effect(Vector2(-8, 0))


func create_hit_effect(correction_v: Vector2 = Vector2.ZERO):
	Utils.defer_instance_to_scene(HitEffect, global_position + correction_v)





