extends Node2D

export(int) var chain_percentage = 43

var Enemy = preload("res://Enemy/NPCShip.tscn")
onready var spawn_points = $SpawnPoints
onready var Timer = $Timer
var prev_index: int
var chain_length: int = 0
var max_chain_length: int = 8


func _ready():
	randomize()


func get_random_bool(yes_prob):
	var random: int = randi() % 100
	if random >= yes_prob:
		return true
	return false
	

func get_spawn_position():
	var points = spawn_points.get_children()
	var start_new: bool = get_random_bool(chain_percentage)
	var random: int = randi()
	var index : int
	
	if chain_length >= max_chain_length:
		start_new = true
		
	if start_new:
		index = random % points.size()
		prev_index = index
		chain_length = 0
	else: 
		index = prev_index + ((random % 3) - 1)
		chain_length += 1
	
	prev_index = int(clamp(index, 1, points.size() - 2))
	return points[index].global_position

func spawn_enemy():
	var spawn_position = get_spawn_position()
	return Utils.defer_instance_to_scene(Enemy, spawn_position)

func start():
	Timer.start()


func _on_Timer_timeout():
	spawn_enemy()
