extends Node

export(int) var FUEL = 50 setget set_fuel
export(int) var MAX_FUEL = 100

onready var bar1 = $Bar1
onready var bar2 = $Bar2
onready var bar3 = $Bar3
onready var alarmplayer = $AlarmPlayer

onready var bar_img_1 = load("res://Resources/Sprites/GUI/Fuel Bar 1.png")
onready var bar_img_2 = load("res://Resources/Sprites/GUI/Fuel Bar 2.png")
onready var bar_img_3 = load("res://Resources/Sprites/GUI/Fuel Bar 3.png")

signal fuel_30pct
signal fuel_20pct
signal fuel_10pct
signal fuel_empty
	
func set_fuel(amount: int):
	var old_fuel = FUEL
	FUEL = clamp(amount, 0, MAX_FUEL)
	
	var fuel_per_step = MAX_FUEL / 3
	var pos: int = 2
	
	for bar in [bar3, bar2, bar1]:
		var remainder = amount - (fuel_per_step * pos)
		if remainder > (2 * (fuel_per_step / 3)):
			bar.set_texture(bar_img_1)
		elif remainder > (fuel_per_step / 3):
			bar.set_texture(bar_img_2)
		elif remainder > 1:
			bar.set_texture(bar_img_3)
		else:
			bar.set_texture(null)
		pos -= 1
	
	if amount == 0:
		alarmplayer.stop()
		emit_signal("fuel_empty")
	elif amount < (MAX_FUEL / 10):
		if not alarmplayer.playing:
			alarmplayer.play()
	else:
		alarmplayer.stop()
	
	if old_fuel > FUEL:
		if FUEL == int(MAX_FUEL / 3):
			emit_signal("fuel_30pct")
		elif FUEL == int(MAX_FUEL / 5):
			emit_signal("fuel_20pct")
		elif FUEL == int(MAX_FUEL / 10):
			emit_signal("fuel_10pct")
