extends Node

var music_playlist = [
	"res://Resources/Sound/Music/SS marschiert im Feindesland (synthie).ogg",
	"res://Resources/Sound/Music/Die_Braune_Kompanie.ogg",
	"res://Resources/Sound/Music/Unsere_Fahne_flattert_Uns_voran.ogg",
	"res://Resources/Sound/Music/Volk_an_s_Gewehr.ogg",
	"res://Resources/Sound/Music/Erika.ogg",
	"res://Resources/Sound/Music/70_Millionen_ein_Schlag.ogg",
	]
var kike_playlist = ["res://Resources/Sound/Music/hava_nagila 2.ogg"]
var scratch_effect = "res://Resources/Sound/Effects/scratch.wav"

var music_pos = 0
var kike_pos = 0
export(int) var volume_db: int = -10

enum states {PLAY_MUSIC, PLAY_KIKE, SWITCH_TO_KIKE, SWITCH_TO_MUSIC}
var state = states.PLAY_MUSIC

onready var MainPlayer = $MainPlayer
onready var ScratchPlayer = $ScratchPlayer


func next_audio():
	var audio_file: String
	
	match state:
		states.SWITCH_TO_MUSIC:
			state = states.PLAY_MUSIC
			return next_audio()
		states.SWITCH_TO_KIKE:
			state = states.PLAY_KIKE
			return next_audio()
		states.PLAY_MUSIC:
			audio_file = music_playlist[music_pos % music_playlist.size()]
			music_pos  += 1
		states.PLAY_KIKE:
			audio_file = kike_playlist[kike_pos % kike_playlist.size()]
			kike_pos += 1

	MainPlayer.stream = load(audio_file)
	MainPlayer.volume_db = volume_db
	MainPlayer.play()


func switch_to_kike():
	state = states.SWITCH_TO_KIKE
	MainPlayer.stop()
	ScratchPlayer.play()

func switch_to_music():
	yield(get_tree().create_timer(1), "timeout")
	state = states.SWITCH_TO_MUSIC
	MainPlayer.stop()
	ScratchPlayer.play()

func switch_playlist():
	match state:
		states.PLAY_KIKE:
			switch_to_music()
		states.PLAY_MUSIC:
			switch_to_kike()

func play_music():
	if state != states.PLAY_MUSIC:
		switch_to_music()

func stop():
	MainPlayer.stop()
	ScratchPlayer.stop()

func _ready():
	next_audio()
